Scriptname pchsTossOut extends Quest  
;/
Event OnInit()
	If Self.IsRunning()

	EndIf
EndEvent
/;

Event OnUpdateGameTime()
	ObjectReference OutsideDoor = (Self.GetNthAlias(2) as ReferenceAlias).GetReference()
	OutsideDoor.Lock(False)
	(Self.GetNthAlias(0) as ReferenceAlias).ForceRefTo(pchsFather)
	Debug.Messagebox("Father will allow me back inside again")
	IsTossedOut = false
	StorageUtil.SetIntValue(None, "pchsWtWartimesHomeAccess", 1)
	pchsTossOutState.SetValue(2.0)
	RestartTasks()
	SendSurvivalBlockEvent(BlockIt = false)
EndEvent

Function BeginTossOut()
	Self.Stop()
	Utility.Wait(0.5)
	Self.Start()
EndFunction

;	(Game.GetFormFromFile(0x2C0EAA, "pchsWartimes.esp") as pchsTossOut).TossOut(IsPermanent = true, SimpleSlavery = false, StripPlayer = true, MoveOutside = true, BlockLicences = false, BountyWhiterun = 0, BountyAll = 0)
Function TossOut(Bool IsPermanent = false, Bool SimpleSlavery = false, Bool StripPlayer = true, Bool MoveOutside = true, Bool BlockLicences = false, Int BountyWhiterun = 0, Int BountyAll = 0)
	;Self.Stop()
	(Self.GetNthAlias(0) as ReferenceAlias).Clear()
	pchsFather.EvaluatePackage()
	If StripPlayer
		DoStripPlayer()
	EndIf
	If MoveOutside
		((Self.GetNthAlias(1) as ReferenceAlias).GetReference() as ObjectReference).Activate(PlayerRef)
	EndIf
	
	TossOutTime = Utility.GetCurrentGameTime()
	IsTossedOut = true
	StorageUtil.SetIntValue(None, "pchsWtWartimesHomeAccess", 0)
	ObjectReference OutsideDoor = (Self.GetNthAlias(2) as ReferenceAlias).GetReference()
	OutsideDoor.Lock()
	OutsideDoor.SetLockLevel(255)
	
	If IsPermanent || pchsTossOutWarning.GetValue() > 0 ; Is permanent
		pchsWartimes.Stop()
		If SimpleSlavery
			If Game.GetModByName("SimpleSlavery.esp") != 255
				Utility.Wait(2.0)
				SendModEvent("SSLV Entry")
			Else
				If !MoveOutside
					; If player is sent for SS but SS is not installed and the player has not been moved outside then at least move the player outside.
					((Self.GetNthAlias(1) as ReferenceAlias).GetReference() as ObjectReference).Activate(PlayerRef)
				EndIf
			EndIf
		EndIf
		Self.Stop()
	Else ; Is warning
		RegisterForSingleUpdateGameTime(24.0 * (Utility.RandomInt(3, 7) as Float))
	EndIf
	
	If BlockLicences
		SendSurvivalBlockEvent(BlockIt = true)
	EndIf
	
	If BountyWhiterun > 0.0
		ModBounty(BountyWhiterun + ((IsPermanent as Int) * BountyWhiterun), CrimeFactionWhiterun)
		Debug.Notification("A bounty has been placed on me in Whiterun")
	EndIf
	
	If BountyAll > 0.0
		Faction akCrimeFact
		Int i = 0
		While i < CrimeFactionsAll.Length
			ModBounty(BountyAll, CrimeFactionsAll[i])
			i += 1
		EndWhile
		If BountyWhiterun == 0.0 ; If whiterun bounty is not specified use bountyAll
			ModBounty(BountyAll + ((IsPermanent as Int) * BountyAll), CrimeFactionWhiterun)
		EndIf
		Debug.Notification("Bounties have been placed on me in all holds")
	EndIf
	
	pchsTossOutWarning.SetValue(1.0)
	pchsTossOutState.SetValue(1.0)
	pchsFatherVoluntaryServeRep.SetValue(0.0)
EndFunction

Function ModBounty(Int Value, Faction akCrimeFact)
	akCrimeFact.ModCrimeGold(Value)
	StorageUtil.SetIntValue(akCrimeFact, "pchsWtTossOutBounty", Value)
EndFunction

Function ClearBounties()
	Int Bounty
	Int i = 0
	While i < CrimeFactionsAll.Length
		Bounty = StorageUtil.GetIntValue(CrimeFactionsAll[i], "pchsWtTossOutBounty", Missing = 0)
		If Bounty > 0
			CrimeFactionsAll[i].ModCrimeGold(-(Bounty))
			StorageUtil.UnSetIntValue(CrimeFactionsAll[i], "pchsWtTossOutBounty")
		EndIf
		i += 1
	EndWhile
	Bounty = StorageUtil.GetIntValue(CrimeFactionWhiterun, "pchsWtTossOutBounty", Missing = 0)
	If Bounty > 0
		CrimeFactionWhiterun.ModCrimeGold(-(Bounty))
		StorageUtil.UnSetIntValue(CrimeFactionWhiterun, "pchsWtTossOutBounty")
	EndIf
EndFunction

Function RestartTasks()
	Float Difference = Utility.GetCurrentGameTime() - TossOutTime
	pchsFatherHungerLastMeal.Mod(Difference)
	pchsFatherThirstLastDrink.Mod(Difference)
	pchsFatherSexTimestamp.Mod(Difference)
	pchsAldoSexTimestamp.Mod(Difference)
	pchsSupplyRunNext.Mod(Difference)
	pchsDirtTimer.Mod(Difference)
	pchsMotherHealthTimestamp.Mod(Difference)
	pchsFatherMilkTimestamp.Mod(Difference)
	pchsFatherCumSlutTimestamp.Mod(Difference)
	pchsFatherForcegreetGlobalTimestamp.Mod(Difference)
EndFunction

Function DoStripPlayer()
	Form akForm
	Int i = PlayerRef.GetNumItems()
	While i > 0
		i -= 1
		akForm = PlayerRef.GetNthForm(i)
		If akForm.GetName() != "" && !akForm.HasKeyword(SexlabNoStrip) && akForm.IsPlayable()
			PlayerRef.RemoveItem(akForm, 999, abSilent = true, akOtherContainer = pchsTossOutChest)
		EndIf
	EndWhile
EndFunction

Function ReturnItems()
	pchsTossOutChest.RemoveAllItems(akTransferTo = PlayerRef, abKeepOwnership = true, abRemoveQuestItems = true)
	pchsTossOutState.SetValue(0.0)
	(Self.GetNthAlias(0) as ReferenceAlias).Clear()
	pchsFather.EvaluatePackage()
	ClearBounties()
	Self.Stop()
EndFunction

Function FatherAttack(Bool DoTossOut = true, Bool IsPermanent = false, Bool SimpleSlavery = false, Bool StripPlayer = true, Bool MoveOutside = true, Bool BlockLicences = false, Int BountyWhiterun = 0, Int BountyAll = 0)
	Weapon akWeapon = pchsFather.GetEquippedWeapon(abLeftHand = false)
	If akWeapon
		 pchsFather.UnequipItem(akWeapon)
	EndIf
	pchsFather.DrawWeapon()
	Utility.WaitMenuMode(2.0)
	Debug.SendAnimationEvent(pchsFather, "attackStart")
	Utility.Wait(0.75)
	Game.ShakeCamera(akSource = None, afStrength = 0.5, afDuration = 3.0)
	Utility.Wait(0.5)
	Game.FadeOutGame(true, true, 0.0, 3.0)
	If DoTossOut
		TossOut(IsPermanent, SimpleSlavery, StripPlayer, MoveOutside, BlockLicences, BountyWhiterun, BountyAll)
	EndIf
	PlayerRef.DamageAv("Health", PlayerRef.GetAv("Health") - 20.0)
	Utility.Wait(3.0)
	Game.FadeOutGame(false, true, 0.0, 6.0)
	Utility.Wait(2.0)
	Debug.SendAnimationEvent(PlayerRef, "OffsetStop")
EndFunction

Function SendSurvivalBlockEvent(Bool BlockIt)
	Int BlockEvent = ModEvent.Create("_SLS_BlockLicenceBuy")
	If (BlockEvent)
		ModEvent.PushForm(BlockEvent, self)
		ModEvent.PushBool(BlockEvent, BlockIt)
		ModEvent.Send(BlockEvent)
	EndIf
EndFunction

Bool Function GetIsTossedOut()
	Return IsTossedOut
EndFunction

Bool IsTossedOut = false

Float TossOutTime

Keyword Property SexlabNoStrip Auto

ObjectReference Property pchsTossOutChest Auto

Actor Property PlayerRef Auto
Actor Property pchsFather Auto

Faction[] Property CrimeFactionsAll Auto
Faction Property CrimeFactionWhiterun Auto

Quest Property pchsWartimes Auto

GlobalVariable Property pchsTossOutWarning Auto ; 0 - No warning, 1 - already warned and tossed out
GlobalVariable Property pchsTossOutState Auto ; 0 - Not tossed out, 1 - Tossed out, locked out, 2 - Tossed out, not locked out, 
GlobalVariable Property pchsFatherVoluntaryServeRep Auto
GlobalVariable Property pchsFatherHungerLastMeal Auto
GlobalVariable Property pchsFatherThirstLastDrink Auto
GlobalVariable Property pchsFatherSexTimestamp Auto
GlobalVariable Property pchsAldoSexTimestamp Auto
GlobalVariable Property pchsSupplyRunNext Auto
GlobalVariable Property pchsDirtTimer Auto
GlobalVariable Property pchsMotherHealthTimestamp Auto
GlobalVariable Property pchsFatherMilkTimestamp Auto
GlobalVariable Property pchsFatherCumSlutTimestamp Auto
GlobalVariable Property pchsFatherForcegreetGlobalTimestamp Auto

pchsWartimesPlayerScript Property PchsPlayer Auto
